    def fi_readline(self):
        "Read a line, stashing comments as we go."
        while True:
            line = self.readline()
            if line and line.startswith("#") and not line.startswith("#legacy-id"):
                self.repo.addEvent(Passthrough(line, self.repo))
                if line.startswith("#reposurgeon"):
                    # Extension command generated by some exporter's
                    # --reposurgeon mode.
                    fields = line.split()
                    if fields[1] == "sourcetype" and len(fields) == 3:
                        self.repo.hint(fields[2], strong=True)
                continue
            else:
                return line

    if newname.count("/") == 0:
        newname = "heads/" + newname

    styleflags = ", ".join(self.styleflags),
    preserve = ", ".join(self.preserve),
    ignores = sep.join(realignores).strip(),
    notes = self.notes.strip()

    if filter_regexp:
        for key in msg.keys():
            if not filter_regexp.match(polybytes(key + ":")):
                del msg[key]

    for repotype in vcstypes + extractors:
        if line.lower() == repotype.name:
            self.preferred = repotype
            break

    filtercmd = self.filtercmd.replace("%PATHS%", pathsubst)

    # Second and third lines are synthetic.  Meant to show that
    # iterating over the repeating transforms works, but it doesn't
    # yet unless the calls happen to be in the right order in the
    # table.
    (h, ci) = line.strip().split('|')
    (h, ci) = line.upper().strip()
    (h, ci) = line.strip().upper()
